$INTERFACE U1FSI1                                             99/12/01
$REM LU
  $N='NF'
  $NN='NC'
  $RDEL='ONE'
  $IF(KBF>0)
    $XSL='XSL'
    $XZL='XZL'
    $XSU='XSU'
    $XZU='XZU'
    $IF(KBF<2)
      $XU=XL
      $XSU=XSL
      $XZU=XZL
    $ENDIF
  $ELSE
    $XSL=X
    $XZL=X
    $XSU=X
    $XZU=X
  $ENDIF
  $IF(KBC>0)
    $CSL='CSL'
    $CZL='CZL'
    $CSU='CSU'
    $CZU='CZU'
    $IF(KBC<2)
      $CU=CL
      $CSU=CSL
      $CZU=CZL
    $ENDIF
  $ELSE
    $NC=1
    $CSL=CF
    $CZL=CF
    $CSU=CF
    $CZU=CF
  $ENDIF
  $NCA='($NX+$NC)'
  $HS=H
  $HERF='S'
  $HESR='S'
  $IF(MODEL='AF') $HESR='B'
  $IF(MODEL='AQ') $HESR='B'
  $IF(MODEL='AP') $HESR='B'
  $IF(MODEL='AM') $HESR='B'
  $IF(MODEL='AA') $HESR='B'
  $ADD(REAL,'\$CFO($NC+1)\$CFD($NC+1)\RMAXP\RMAXD\TOLP')
  $ADD(INTEGER,'\IMD')
  $ADD(REAL,'\UXUDOT')
  $ADD(REAL,'\UXVDOT')
  $CONSTR='U'
  $MODP='FF'
  $IF(MODEL='AF') $MODP=MODEL
  $IF(MODEL='AQ') $MODP=MODEL
  $IF(MODEL='AP') $MODP=MODEL
  $IF(MODEL='AM') $MODP='AF'
  $IF(MODEL='AA') $MODP='AF'
  $HELP
    TYPE OF THE METHOD:
      L - LINE SEARCH
      G - TRUST REGION
  $CHECK(TYPE,'L','L\G',2,NO)
  $DECOMP='I'
  $IF(MODELA='YES')
    $IF(ISNA<1) $ISNA=1
    $ADD(INIT)
      ISNA=$ISNA
    $ENDADD
  $ENDIF
  $ISNC=2
  $ADD(INIT)
    ISNC=2
  $ENDADD
  $KDS=0
  $HELP
    STRATEGY FOR UPDATES OF SLACK VARIABLES
      1 - SLACK VARIABLES ARE DETERMINED BY LINE SEARCH
      2 - SLACK VARIABLES ARE DETERMINED FROM CONSTRAINTS
  $CHECK(MOP1,1,'1\2',4)
 $HELP
    STRATEGY FOR UPDATES OF BOX CONSTRAINTS
      1 - BOX CONSTRAINTS ARE DETERMINED BY LINE SEARCH
      2 - INITIAL BOX CONSTRAINTS ARE FEASIBLE
      3 - BOX CONSTRAINTS ARE ALWAYS FEASIBLE
  $CHECK(MOP2,1,'1\2\3',4)
  $HELP
    IP FORMULATION
      1 - PRIMAL
      2 - PRIMAL-DUAL
  $CHECK(MEP1,2,'1\2',4)
  $HELP
    STRATEGY FOR PRIMAL AND DUAL STEPSIZES
      0      - UCISTP
     -1 OR 1 - R, MIN(R,RMAXP), MIN(R,RMAXD)
     -2 OR 2 - R, MIN(R,RMAXP), MIN(R,RMAXP,RMAXD)
     -3 OR 3 - R, MIN(R,RMAXP,RMAXD), MIN(R,RMAXP,RMAXD)
    MEP2 > 0 - R <= RMAX
    MEP2 < 0 - R <= MIN(RMAX, RMAXP)
  $CHECK(MEP2,0,'-3\-2\-1\0\1\2\3',4)
  $NEP2=MEP2
  $IF(NEP2=-1) $NEP2=1
  $IF(NEP2=-2) $NEP2=2
  $IF(NEP2=-3) $NEP2=3
  $HELP
    CHOICE OF THE BARRIER COEFFICIENT
      -1 OR 1 - VANERBEI AND SHANNO
      -2 OR 2 - EL-BAKRY
     MEP3 > 0 - BASIC STRATEGY
     MEP3 < 0 - MONOTONE DECREASING STRATEGY
  $CHECK(MEP3,1,'-2\-1\1\2',4)
  $NEP3=MEP3
  $IF(NEP3=-1) $NEP3=1
  $IF(NEP3=-2) $NEP3=2
  $IF(TYPE='L')
    $IF(NCE=0)
      $HELP
         METHOD
           1 - EXACT SOLUTION WITH BUNCH PARLETT DECOMPOSITION
           2 - EXACT SOLUTION WITH GILL MURRAY DECOMPOSITION
           3 - INEXACT SOLUTION BY SMOOTHED CONJUGATE GRADIENT
               METHOD
      $CHECK(NUMBER,3,'1\2\3',2,NO)
    $ELSE
      $HELP
         METHOD
           1 - EXACT SOLUTION WITH BUNCH PARLETT DECOMPOSITION
           3 - INEXACT SOLUTION BY SMOOTHED CONJUGATE GRADIENT
               METHOD
      $CHECK(NUMBER,3,'1\3',2,NO)
    $ENDIF
    $IF(NUMBER=2)
      IF (NCE.GT.0) THEN
      CALL UOERR1('U2FSP1',119)
      ITERM=-119
      GO TO $80
      END IF
      $NCA=1
    $ENDIF
    $HELP
      CHOICE OF THE MERIT STRATEGY:
        P - PENALTY FUNCTION
        M - MARKOV FILTER
        F - FLETCHER-LEYFFER FILTER
        B - BARRIER FILTER
        S - NEW FILTER
    $CHECK(MERIT,'P','P\M\F\B\S',2,NO)
    $HELP
      BARRIER COEFFICIENT
    $CHECK(RPF3,'1.0$P 0',REAL,3)
    $IF(MERIT='P')
      $HELP
        MERIT FUNCTION
          0 - MERIT FUNCTION IS NOT USED
          1 - L2 AUGMENTED BARRIER FUNCTION
          2 - L2 AUGMENTED LAGRANGIAN FUNCTION
      $CHECK(MEP,1,'0\1\2',2)
      $IF(MEP=0) $KTERS=6
      $HELP
        PENALTY COEFFICIENT
      $CHECK(RPF1,'1.0$P-4',REAL,3)
      $STEP=1
    $ELSEIF(MERIT='M')
      $FS='FS'
      $ADD(REAL,'\$FS(2)')
      $MEP=-1
      $MEP2=1
      $STEP=8
    $ELSEIF(MERIT='B')
      $ADD(REAL,'\FB')
      $HELP
        MAXIMUM NUMBER OF FILTER SAMPLES
      $CHECK(MS,50,INT,3)
      $IF(MS<5) $MS=5
      $FS='FS'
      $ADD(REAL,'\$FS($MS,4)')
      $MEP=-1
      $MEP2=1
$REM      $STEP=9
      $STEP=7
    $ELSE
      $HELP
        MAXIMUM NUMBER OF FILTER SAMPLES
      $CHECK(MS,50,INT,3)
      $IF(MS<5) $MS=5
      $FS='FS'
      $ADD(REAL,'\$FS($MS,2)')
      $MEP=-1
      $MEP2=1
$REM      $STEP=9
      $STEP=7
      $IF(MERIT='S')
        $ADD(REAL,'\SWITCH')
        $STEP=10
      $ENDIF
    $ENDIF
    $HELP
      TYPE OF KKT REGULARIZATION
        0 - NO REGULARIZATION
        1 - REGULARIZATION BY GILL-MURRAY DECOMPOSITION
    $CHECK(MEP4,0,'0\1',4)
    $IF(MEP4=0)
      $ED=S
    $ELSE
      $ED='ED'
      $ADD(REAL,'\$ED($NCA)')
      $HELP
        TOLERANCE FOR POSITIVE DEFINITENESS
      $CHECK(ETA2,'1.0$P-8',REAL,4)
    $ENDIF
    $IF(MERIT='P')
       $IF(MEP>0) $MES5=1
    $ENDIF
    $HELP
      RESTART IN THE CASE OF UNSUITABLE DIRECTION
        0 - RESTART SUPPRESSED
        1 - UNIFORM DESCENT ASSURED
    $CHECK(MES5,0,'0\1',4)
    $HELP
      TOLERANCE FOR DESCENT DIRECTION
    $CHECK(EPS0,'1.0$P-8',REAL,4)
    $IF(NUMBER=1) $MOS2=0
    $HELP
      PRECONDITIONING THE KARUSH-KUHN-TUCKER SYSTEM
             0 - PRECONDITIONING IS SUPPRESSED
       -1 OR 1 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
                 APPROXIMATION OF THE HESSIAN MATRIX. NORMAL
                 EQUATION APPROACH.
             2 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
                 APPROXIMATION OF THE HESSIAN MATRIX. AUGMENTED
                 SYSTEM APPROACH.
       -3 OR 3 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
                 PERTURBATION OF THE SCHUR COMPLEMENT
      MOS2 > 0 - COMPLETE CHOLESKI DECOMPOSITION
      MOS2 < 0 - INCOMPLETE CHOLESKI DECOMPOSITION
    $CHECK(MOS2,1,'-3\-1\0\1\2\3',3)
    $NOS2=MOS2
    $IF(NOS2=-1) $NOS2=1
    $IF(NOS2=-3) $NOS2=3
    $HELP
      KKT NORM INCREASING
        0 - KKT NORM INCREASING SUPPRESSED
        1 - KKT NORM INCREASING IN MES4 ITERATIONS
    $CHECK(MES4,0,INT,4)
    $IF(MES4>0)
      $HELP
        UPPER BOUND FOR KKT NORM INCREASING
      $CHECK(ETA8,'1.0$P 0',REAL,4)
    $ENDIF
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,1,'1\2\3\4',4)
    $DEFAULT=ETA0
$REM    $IF(NUMBER=2) $DEFAULT='0.0$P 0'
    $HELP
      MINIMUM VALUE OF THE BARRIER PARAMETER
    $CHECK(ETA5,DEFAULT,REAL,3)
    $DEFAULT='0.99$P 0'
    $IF(MEP=1) $DEFAULT='0.95$P 0'
    $HELP
      COEFFICIENT FOR COMPUTING PRIMAL AND DUAL MAXIMUM
      STEPSIZES
    $CHECK(ETA6,DEFAULT,REAL,3)
    $HELP
      MAXIMUM STEPSIZE FOR LAGRANGE MULTIPLIERS
    $CHECK(UMAX,'1.0$P 6',REAL,3)
  $ELSEIF(TYPE='G')
    $NUMBER=3
    $MERIT='P'
    $RDEL='RDEL'
    $ADD(REAL,'\RDEL')
    $HELP
      MERIT FUNCTION
        1 - L2 AUGMENTED BARRIER FUNCTION
        2 - SIMPLIFIED L2 AUGMENTED BARRIER FUNCTION
    $CHECK(MEP,1,'1\2',2)
    $MEP4=0
    $ED=S
    $MES5=1
    $MOS2=1
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P-4',REAL,3)
    $HELP
      MINIMUM VALUE OF THE BARRIER PARAMETER
    $CHECK(ETA5,ETA0,REAL,3)
    $DEFAULT='0.99$P 0'
    $IF(MEP=1) $DEFAULT='0.95$P 0'
    $HELP
      COEFFICIENT FOR COMPUTING PRIMAL AND DUAL MAXIMUM
      STEPSIZES
    $CHECK(ETA6,DEFAULT,REAL,3)
    $HELP
      MAXIMUM STEPSIZE FOR LAGRANGE MULTIPLIERS
    $CHECK(UMAX,'1.0$P 6',REAL,3)
  $ENDIF
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      0 - INITIAL APPROXIMATION IS SPECIFIED IN THE CALLING
          PROGRAM
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
      3 - DIAGONAL INITIAL APPROXIMATION
  $CHECK(INITH,1,'0\1\2\3',4)
  $IF(HESR='B')
    $HELP
      TYPE OF SPARSE UPDATE:
        M - BASIC MARWILL UPDATE
        B - PARTITIONED VARIABLE METRIC UPDATES
    $CHECK(UPDATE,'B','M\B',3,NO)
    $IF(UPDATE='B')
      $IF($DEF(MET3))
        $IF(MET3=3) $MET3=1
      $ENDIF
      $HELP
        SUBJECTS OF UPDATES
          0 - CONSTRAINT FUNCTIONS
          1 - CONSTRAINT FUNCTIONS MULTIPLIED BY SIGNS
              OF THE LAGRANGIAN MULTIPLIERS
          2 - ACTIVE TERMS OF THE LAGRANGIAN FUNCTION
          3 - ALL TERMS OF THE LAGRANGIAN FUNCTION
      $CHECK(MET5,1,'0\1\2\3',4)
      $SUBST('UFSET2')
      $SUBST('UCSET6')
      $ISNA=2
      $ADD(INIT)
        ISNA=2
      $ENDADD
    $ELSE
      $HESR='S'
    $ENDIF
  $ELSE
    $UPDATE='M'
  $ENDIF
  $IF(UPDATE='M')
    $HH='HH'
    $ADD(REAL,'\$HH($MMAX)')
  $ENDIF
  $MCL=NC
   MCL=NC
  $GN=GF
  $SN=S
  NDECF=0
  $SUBST('UFSET1')
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL=NAL
     MAL=NAL
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(NCL>0)
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL3')
    $IF(NORMF>0) $SUBST('UCTRL3')
  $ENDIF
  $IF(MODELF='YES')
$REM    $NUM=5
  $ELSE
$REM    $NUM=6
  $ENDIF
  $IF(NUMBER=2)
    $SUBST('UYSFSH')
  $ELSEIF($DEF(MOS2))
    $IF(MOS2=3)
      $SUBST('UYSFSH')
    $ENDIF
  $ENDIF
  $JOB=NUMBER
  $HF=H
*
*     --------------------
*     SPARSE NEWTON METHOD
*     TEMPLATE : U1FSI1
*     --------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO2(FMIN,FO)
  $IF(KBF>0)
    CALL UXVINI(NF,$IX)
  $ENDIF
  R=ZERO
  NCA=-1
  $IF(NUMBER=2)
    IF (ETA5.LE.ZERO) THEN
      TOLP=ETA0**(TWO/THREE)
    ELSE
      TOLP=ETA5
    ENDIF
  $ELSE
    TOLP=ETA5
  $ENDIF
  IF (ITERM.NE.0) GO TO $80
$L=$ 10 ; $LABEL
  $KD=1
  $SUBST('UP1$(MODP)5')
  CF(NC+1)=FF
  IF (TSS(NS).EQ.'UUXX') THEN
  ELSE IF (TSS(NS).EQ.'UXFU') THEN
  ELSE
  $IF(TYPE='L')
    $IF(MERIT='M')
      $SUBST('UP0BF9')
      F=CF(NC+1)+RPF3*F
    $ELSEIF(MERIT='F')
      $SUBST('UP0BF9')
      F=CF(NC+1)
    $ELSEIF(MERIT='B')
      $SUBST('UP0BF9')
      FB=F
      F=CF(NC+1)+RPF3*F
    $ELSEIF(MERIT='S')
      $SUBST('UP0BF9')
      F=CF(NC+1)
    $ELSEIF(MEP=0)
      F=CF(NC+1)
    $ELSEIF(MEP=1)
      $IF(MEP2=0)
        $SUBST('UP0BF2')
      $ELSE
        $SUBST('UP0BF1')
      $ENDIF
    $ELSEIF(MEP=2)
      $IF(MEP2=0)
        $SUBST('UP0AF6')
      $ELSE
        $SUBST('UP0AF5')
      $ENDIF
    $ENDIF
    $IF(MES4>0)
      $ADD(INTEGER,'\NITO')
      $ADD(REAL,'\RES\RESO')
      IF (MODE.EQ.0) THEN
      CALL UCIRES(NF,NX,NC,$X,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF,$IC&
,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$G,RPF3,RES,MEP1)
      IF (RES.LE.1.2$P 0*RESO) THEN
      IF (F.LE.1.0$P 6*FO) ITERS=6
      ELSE
      NITO=NIT
      RESO=RES
      ENDIF
      ENDIF
    $ENDIF
  $ELSEIF(TYPE='G')
    $IF(MERIT='M')
      $SUBST('UP0BF9')
      F=CF(NC+1)+RPF3*F
    $ELSEIF(MERIT='F')
      $SUBST('UP0BF9')
      F=CF(NC+1)
    $ELSEIF(MERIT='B')
      $SUBST('UP0BF9')
      FB=F
      F=CF(NC+1)+RPF3*F
    $ELSEIF(MEP=0)
      F=CF(NC+1)
    $ELSEIF(MEP=1)
      $IF(MEP2=0)
        $SUBST('UP0BF2')
      $ELSE
        $SUBST('UP0BF1')
      $ENDIF
    $ELSEIF(MEP=2)
      $IF(MEP2=0)
        $SUBST('UP0BS2')
      $ELSE
        $SUBST('UP0BS1')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(KDS<1)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXUDOT(NF,$G,$S,$IX,-KBF)
  $ENDIF
  ENDIF
  GO TO IMD
$L=$ 20 ; $LABEL
  $IF(MERIT='M')
  $ELSEIF(MERIT='F')
    $SUBST('UP0BF9')
    F=CF(NC+1)
    KS=1
    FS(1,1)=F
    FS(1,2)=FC
  $ELSEIF(MERIT='B')
    $SUBST('UP0BF9')
    FB=F
    F=CF(NC+1)+RPF3*F
    KS=1
    FS(1,1)=F
    FS(1,2)=FC
    FS(1,3)=FF
    FS(1,4)=FB
  $ELSEIF(MERIT='S')
    $SUBST('UP0BF9')
    F=CF(NC+1)
    KS=1
    FS(1,1)=F
    FS(1,2)=FC
    $IF(MEP3=1)
      KT=0
    $ENDIF
  $ENDIF
  $IF(MES4>0)
    NITO=NIT
    CALL UCIRES(NF,NX,NC,$X,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF,$IC&
,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$G,RPF3,RESO,MEP1)
  $ENDIF
$L=$ 30 ; $LABEL
  $IF(MES4>0)
    IF (NIT-NITO.GT.MES4) THEN
    NITO=NIT
    RESO=RES
    ENDIF
  $ENDIF
  $SUBST('UYTS$(CONSTR)G')
  $SUBST('UO2FN4')
  $SUBST('UYFUT2')
  IF (GMAX.LE.TOLG.AND.CMAX.LE.TOLC.AND.RPF3.LE.TOLP) THEN
  ITERM=4
  TXFU='GRAD TOL'
  ENDIF
$REM  IF (ITERM.EQ.1.AND.ABS(F).GE.1.0$P 10) THEN
  IF (.FALSE.) THEN
  CALL UOERR1('U1FSI1',88)
  ITERM=-88
  TDXX='LIN. DEP.'
  ENDIF
  IF (ITERM.NE.0) GO TO $80
  $IF(TYPE='G')
    RDEL=ONE
  $ENDIF
$L=$ 40 ; $LABEL
  $IF(UPDATE='B')
    $SUBST('UUBSD1')
    $SUBST('UUCSD1')
  $ELSE
    $H=HH
    $SUBST('UUSSD1')
    $H=HS
  $ENDIF
  IF (ITERM.NE.0) GO TO $80
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)S')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(KBF>0)
    CALL UXVINF(NF,M,$IX,$JH)
    CALL UXVINF(NF,MC,$IX,$JCG)
    $IF(MODELA='YES') CALL UXVINF(NF,MA,$IX,$JAG)
  $ENDIF
  $IF(HESR='B')
    $SUBST('UYT$(HESR)$(CONSTR)H')
    $SUBST('UFSET4')
    $SUBST('UFSET6')
  $ELSE
    CALL UXVCOP(IH(NF+1)-1,$HH,$HS)
    $SUBST('UYT$(HESR)$(CONSTR)H')
  $ENDIF
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UDS$(TYPE)$(DECOMP)$(NUMBER)
*     -----------------------
*
  $SUBST('UDS$(TYPE)$(DECOMP)$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $IF(MERIT='S')
    SWITCH=UXSSMQ(NF,M,HF,IH,JH,S,S)
  $ENDIF
  $IF(TYPE='L')
    $SUBST('UD1T$(TYPE)3')
  $ELSEIF(TYPE='G')
    $ADD(REAL,'\UXUNOR')
    CALL UD1TG3(NF,$G,$S,P,PP,UXUNOR(NF,G,IX,-KBF),UXUNOR(NF,S,IX,-KBF)&
,RMAX,XMAX)
  $ENDIF
  $IF(MEP2=0)
  $ELSE
  CALL UCIMAX(NF,NX,NC,NCA,$X,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CFD,$IC&
,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$ICA,$S,$GS(NF+1),$XO(NF+1),$GO(NF+1),RMAX&
,RMAXP,RMAXD,ETA6)
    $IF(MEP2<0)
      RMAX=MIN(RMAX,RMAXP)
    $ENDIF
  $ENDIF
$REM  $IF(KBF>0)
$REM    CALL UXVINE(M,$JH)
$REM    CALL UXVINE(MC,$JCG)
$REM    $IF(MODELA='YES') CALL UXVINE(MA,$JAG)
$REM  $ENDIF
  $IF(TYPE='L')
    $IF(MERIT='M')
      $SUBST('UP0BF9')
      FS(1)=CF(NC+1)+RPF3*F
      FS(2)=FC
    $ELSEIF(MEP=0)
      F=CF(NC+1)
    $ELSEIF(MEP=1)
      $IF(MEP2=0)
        $SUBST('UP0BF2')
      $ELSE
        $SUBST('UP0BF1')
      $ENDIF
    $ELSEIF(MEP=2)
      $IF(MEP2=0)
        $SUBST('UP0AF6')
      $ELSE
        $SUBST('UP0AF5')
      $ENDIF
    $ENDIF
  $ELSEIF(TYPE='G')
    $IF(MERIT='M')
      $SUBST('UP0BF9')
    $ELSEIF(MEP=0)
      F=CF(NC+1)
    $ELSEIF(MEP=1)
      $IF(MEP2=0)
        $SUBST('UP0BF2')
      $ELSE
        $SUBST('UP0BF1')
      $ENDIF
    $ELSEIF(MEP=2)
      $IF(MEP2=0)
        $SUBST('UP0BS2')
      $ELSE
        $SUBST('UP0BS1')
      $ENDIF
    $ENDIF
  $ENDIF
  IF (ITERM.NE.0) GO TO $80
  IF (IREST.NE.0) GO TO $40
$L=$ 50 ; $LABEL
  $SUBST('UYTR$(CONSTR)S')
  CALL UXVCOP(NC+1,$CF,$CFO)
  $IF(HESR='B')
    CALL UXVCOP(MA,$AG,$AGO)
    CALL UXVCOP(MC,$CG,$CGO)
  $ENDIF
$L=$ 60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  GOTO ($64,$62) ISB+1
$L=$ 62 ; $LABEL
  $IF(MOP2=3)
    CALL UXUDIC(NF,R,$S,$XO,$XL,$XU,$X,$IX)
  $ELSE
    CALL UXUDIR(NF,R,$S,$XO,$X,$IX,-KBF)
  $ENDIF
  $IF(HESR='B')
    ISNA=1
  $ENDIF
  ISNC=1
  GOTO $10
$L=$ 64 ; $LABEL
  $IF(MERIT='B')
    FS(KS,3)=FF
    FS(KS,4)=FB
  $ENDIF
  $IF(HESR='B')
    ISNA=2
    $IF(KDA=1) LD=0
  $ENDIF
  ISNC=2
  $IF(KDC=1) LD=0
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
    $IF(HESR='B')
      CALL UXVCOP(MC,$CGO,$CG)
      CALL UXVCOP(MA,$AGO,$AG)
    $ENDIF
  $ENDIF
  CALL UXVCOP(NC+1,$CFO,$CF)
  $IF(TYPE='G')
    RDEL=RDEL*XDEL/XDELO
  $ENDIF
  IF (IDIR.EQ.0) CALL UYRES1(TSXX)
  CALL UYSET1
  GOTO $40
  ENDIF
  $IF(MEP2=0)
    CALL UCISTP(NF,NX,NC,NCA,$XO,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF&
,$CFD,$IC,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$ICA,$S,$GS(NF+1),$XO(NF+1)&
,$GO(NF+1),R,ETA6,$MOP1)
  $ELSE
    RMAXP=MIN(R,RMAXP)
    RMAXD=MIN(R,RMAXD)
    $IF(NEP2=2)
      RMAXD=MIN(RMAXP,RMAXD)
    $ENDIF
    $IF(NEP2=3)
      RMAXD=MIN(RMAXP,RMAXD)
      RMAXP=RMAXD
    $ENDIF
    CALL UCIDIR(NF,NX,NC,NCA,$XO,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF&
,$CFD,$IC,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$ICA,$S,$GS(NF+1),$XO(NF+1)&
,$GO(NF+1),R,RMAXP,RMAXD,$RDEL,$MOP1)
  $ENDIF
  CALL UODLI5(R,RMAX,RMAXP,RMAXD)
  ALF=RPF3
  $SUBST('UPSEB$NEP3')
  $IF(MEP3<0)
    RPF3=MIN(RPF3,ALF)
  $ENDIF
  RPF3=MAX(RPF3,TOLP)
  $IF(MERIT='B')
    CALL UPSETB(KS,$MS,$FS,RPF3)
  $ENDIF
  $IF(HESR='B')
  $ELSE
$REM    IF (NIT.NE.LIT+1) THEN
    $GFS=GF
    $IF(MODP<>'FF') $GF=GA
    CALL UCILAG(NF,NX,NC,MC,$IX,$XZL,$XZU,$GF,$IC,$CZL,$CZU,$CG&
,$ICG,$JCG,$GO)
    $GF=GFS
$REM    ENDIF
  $ENDIF
  IF (KD.GT.LD) THEN
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$ 70 ; $LABEL
  TXFU=TUXX
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYUP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(HESR='B')
    $HELP
      SELECTION OF SELF SCALING:
        1 - SELF SCALING SUPPRESSED
        2 - INITIAL SELF SCALING
        3 - CONTROLLED SELF SCALING
        4 - INTERVAL SELF SCALING
        5 - SELF SCALING IN EACH ITERATION
    $CHECK(MET1,3,'1\2\3\4\5',4)
    $IF(KBF>0) CALL UXVINF(NF,MA,$IX,$JAG)
    $SUBST('UYTC$(CONSTR)B')
    IDECF=0
$REM    $IHLP=1
    $IHLP=2
    $SUBST('UUB$(UPDATE)M$(IHLP)')
    $SUBST('UUC$(UPDATE)M$(IHLP)')
  $ELSE
    $H=HH
    $SUBST('UYTR$(CONSTR)D')
    IDECF=0
    $IF(KBF>0) CALL UXVINF(NF,M,$IX,$JH)
    KBF=-KBF
    $SUBST('UUS$(UPDATE)M1')
    KBF=-KBF
$REM    $H=HS
  $ENDIF
  IF (ITERH.NE.0) CALL UYRES1('UPDATE  ')
  GOTO $30
$L=$ 80 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL3')
    $IF(NORMC>0) $SUBST('UCNRL3')
  $ENDIF
  F=CF(NC+1)
  $SUBST('UCTRF3')
  $SUBST('UO1FN2')
  $ADD(INIT)
    NXFU='U1FSI1'
  $ENDADD
  $EXIT
