$INTERFACE U2FSF1                                             01/12/01
$REM LU
  $N='NF'
  $NN='NC'
  $IF(KBF>0)
    $XSL='XSL'
    $XZL='XZL'
    $XSU='XSU'
    $XZU='XZU'
    $IF(KBF<2)
      $XU=XL
      $XSU=XSL
      $XZU=XZL
    $ENDIF
  $ELSE
    $XSL=X
    $XZL=X
    $XSU=X
    $XZU=X
  $ENDIF
  $IF(KBC>0)
    $CSL='CSL'
    $CZL='CZL'
    $CSU='CSU'
    $CZU='CZU'
    $IF(KBC<2)
      $CU=CL
      $CSU=CSL
      $CZU=CZL
    $ENDIF
  $ELSE
    $NC=1
    $CSL=CF
    $CZL=CF
    $CSU=CF
    $CZU=CF
  $ENDIF
  $NCA='($NX+$NC)'
  $HERF='S'
  $ADD(REAL,'\$CFO($NC+1)\$CFD($NC+1)\RMAXD')
  $ADD(INTEGER,'\IMD')
  $ADD(REAL,'\UXUDOT')
  $ADD(REAL,'\UXVDOT')
  $CONSTR='U'
  $TYPE='L'
  $MODP='FF'
  $ADD(INTEGER,'\ISNCS')
  $IF(MODEL='AF') $MODP=MODEL
  $IF(MODEL='AQ') $MODP=MODEL
  $IF(MODEL='AP') $MODP=MODEL
  $IF(MODEL='A?') $ADD(INTEGER,'\ISNAS')
  $HELP
    TYPE OF THE METHOD:
      L - LINE SEARCH
      G - TRUST REGION
  $CHECK(TYPE,'L','L\G',2,NO)
  $DECOMP='F'
  $IF(MODELA='YES')
    $IF(ISNA<1) $ISNA=1
    $ADD(INIT)
      ISNA=$ISNA
    $ENDADD
  $ENDIF
  $ISNC=2
  $ADD(INIT)
    ISNC=2
  $ENDADD
  $KDS=0
  $HELP
    STRATEGY FOR UPDATES OF SLACK VARIABLES
      1 - SLACK VARIABLES ARE DETERMINED BY LINE SEARCH
      2 - SLACK VARIABLES ARE DETERMINED FROM CONSTRAINTS
  $CHECK(MOP1,1,'1\2',4)
 $HELP
    STRATEGY FOR UPDATES OF BOX CONSTRAINTS
      1 - BOX CONSTRAINTS ARE DETERMINED BY LINE SEARCH
      2 - INITIAL BOX CONSTRAINTS ARE FEASIBLE
      3 - BOX CONSTRAINTS ARE ALWAYS FEASIBLE
  $CHECK(MOP2,1,'1\2\3',4)
  $MEP2=0
  $HELP
    CHOICE OF THE LAGRANGIAM MULTIPLIERS
      0 - FREE LAGRANGE MULTIPLIERS
      1 - POSITIVE LAGRANGE MULTIPLIERS
  $CHECK(MEP2,0,'0\1',4)
  $IF(TYPE='L')
    $HELP
       METHOD
         1 - EXACT SOLUTION WITH BUNCH PARLETT DECOMPOSITION
         3 - INEXACT SOLUTION BY SMOOTHED CONJUGATE GRADIENT
             METHOD
    $CHECK(NUMBER,3,'1\3',2,NO)
    $HELP
      CHOICE OF THE MERIT STRATEGY:
        P - PENALTY FUNCTION
        M - MARKOV FILTER
        F - FLETCHER-LEYFFER FILTER
        S - NEW FILTER
    $CHECK(MERIT,'P','P\M\F\S',2,NO)
    $IF(MERIT='P')
      $HELP
        MERIT FUNCTION
          0 - MERIT FUNCTION IS NOT USED
          2 - L2 AUGMENTED LAGRANGIAN FUNCTION
      $CHECK(MEP,0,'0\2',2)
      $IF(MEP=0) $KTERS=6
      $HELP
        PENALTY COEFFICIENT
      $CHECK(RPF1,'1.0$P-4',REAL,3)
      $STEP=1
      $HELP
        CHOICE OF THE LAGRANGIAM MULTIPLIERS
          0 - USING PENALTY FUNCTION
          1 - COMBINATION OF PENALTY AND RESIDUAL FUNCTION
          2 - USING RESIDUAL FUNCTION
      $CHECK(MEP3,0,'0\1\2',4)
    $ELSEIF(MERIT='M')
      $FS='FS'
      $ADD(REAL,'\$FS(2)')
      $MEP=-1
      $MEP3=0
      $STEP=8
    $ELSE
      $HELP
        CHOICE OF THE LAGRANGIAM MULTIPLIERS
          0 - USING PENALTY FUNCTION
          1 - COMBINATION OF PENALTY AND RESIDUAL FUNCTION
      $CHECK(MEP3,0,'0\1',4)
      $IF(MEP3>0)
        $HELP
          TERMINATION TOLERANCE FOR LINE SEARCH (IN TEST
          ON THE CHANGE OF THE RESIDUAL FUNCTION VALUE)
        $CHECK(EPS4,'1.0$P-8',REAL,4)
      $ENDIF
      $HELP
        MAXIMUM NUMBER OF FILTER SAMPLES
      $CHECK(MS,50,INT,3)
      $IF(MS<5) $MS=5
      $FS='FS'
      $ADD(REAL,'\$FS($MS,2)\FFO\FCO')
      $IF(MEP3>0)
        $HELP
          MAXIMUM NUMBER OF FILTER SAMPLES
        $CHECK(MT,50,INT,3)
        $IF(MT<5) $MT=5
        $FT='FT'
        $ADD(REAL,'\$FT($MT,2)')
      $ENDIF
      $MEP=-1
      $STEP=9
$REM      $STEP=7
      $IF(MERIT='S')
        $ADD(REAL,'\SWITCH')
        $STEP=10
      $ENDIF
    $ENDIF
    $HELP
      TYPE OF KKT REGULARIZATION
        0 - NO REGULARIZATION
        1 - REGULARIZATION BY GILL-MURRAY DECOMPOSITION
    $CHECK(MEP4,0,'0\1',4)
    $IF(MEP4=0)
      $ED=S
    $ELSE
      $ED='ED'
      $ADD(REAL,'\$ED($NCA)')
      $HELP
        TOLERANCE FOR POSITIVE DEFINITENESS
      $CHECK(ETA2,'1.0$P-8',REAL,4)
    $ENDIF
    $HELP
      TYPE OF HESSIAN REGULARIZATION
        0 - NO REGULARIZATION
        1 - REGULARIZATION BY SCALED UNIT MATRIX
        2 - REGULARIZATION BY INEXACT DIFFERENTIATION
    $CHECK(MEP5,0,'0\1\2',4)
    $IF(MEP5=1)
      $HELP
        SCALING FACTOR
      $CHECK(TET2,'1.0$P-4',REAL,4)
    $ENDIF
    $IF(MEP2=1)
      $HELP
        INITIAL VALUE OF LAGRANGE MULTIPLIERS
      $CHECK(EPS8,'1.0$P-1',REAL,4)
    $ENDIF
    $IF(NUMBER=1) $MOS2=0
    $HELP
      PRECONDITIONING THE KARUSH-KUHN-TUCKER SYSTEM
             0 - PRECONDITIONING IS SUPPRESSED
       -1 OR 1 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
                 APPROXIMATION OF THE HESSIAN MATRIX. NORMAL
                 EQUATION APPROACH.
             2 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
                 APPROXIMATION OF THE HESSIAN MATRIX. AUGMENTED
                 SYSTEM APPROACH.
       -3 OR 3 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
                 PERTURBATION OF THE SCHUR COMPLEMENT
      MOS2 > 0 - COMPLETE CHOLESKI DECOMPOSITION
      MOS2 < 0 - INCOMPLETE CHOLESKI DECOMPOSITION
    $CHECK(MOS2,1,'-3\-1\0\1\2\3',3)
    $NOS2=MOS2
    $IF(NOS2=-1) $NOS2=1
    $IF(NOS2=-3) $NOS2=3
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,1,'1\2\3\4',4)
  $ENDIF
  $HELP
    COMPUTATION OF SECOND DERIVATIVES
      1 - SECOND DERIVATIVES OF APPROXIMATING AND CONSTRAINT
          FUNCTIONS ARE COMPUTED
      2 - COLEMAN-MORE GRAPH COLORING ALGORITHM IS USED
  $CHECK(NUMDER,2,'1\2',4,NO)
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      0 - INITIAL APPROXIMATION IS SPECIFIED IN THE CALLING
          PROGRAM
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
      3 - DIAGONAL INITIAL APPROXIMATION
  $CHECK(INITH,3,'0\1\2\3',4)
  $MCL=NC
   MCL=NC
  $GN=GF
  $SN=S
  NDECF=0
  $SUBST('UFSET1')
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL=NAL
     MAL=NAL
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(NCL>0)
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL3')
    $IF(NORMF>0) $SUBST('UCTRL3')
  $ENDIF
  $VAL='0.0$P 0'
  $IF(MEP2=1) $VAL=EPS8
  $ADD(SINID)
    $IF($DEF(KBF))
      $IF(KBF>0)
        CALL UXVSET(NX,$VAL,XZL)
      $ENDIF
      $IF(KBF>1)
        CALL UXVSET(NX,$VAL,XZU)
      $ENDIF
    $ENDIF
    $IF($DEF(KBC))
      $IF(KBC>0)
        CALL UXVSET(NC,$VAL,CZL)
      $ENDIF
      $IF(KBC>1)
        CALL UXVSET(NC,$VAL,CZU)
      $ENDIF
    $ENDIF
  $ENDADD
  $IF(MODEL='FQ')
  $ELSEIF(MODELF='YES')
$REM    $NUM=7
    $IF(KDF<2) $SUBST('UYPTSH')
  $ELSE
$REM    $NUM=8
    $IF(KDC<2)
      $IF(KDA<2)
        $IF(NUMDER=2) $SUBST('UYPTSH')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF($DEF(MOS2))
    $IF(MOS2=3)
      $SUBST('UYSFSH')
    $ENDIF
  $ENDIF
  $JOB=NUMBER
  $IF (MODEL<>'FQ') $HF=H
*
*     --------------------
*     SPARSE NEWTON METHOD
*     TEMPLATE : U2FSF1
*     --------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',2)
  CALL UYPRO3(0)
  $IF(KBF>0)
    CALL UXVINI(NF,$IX)
  $ENDIF
  R=ZERO
  FO=FMIN
  $IF(MEP3=1)
    $ADD(REAL,'\FQ\FQO')
    $IF(MERIT='P')
      FQO=ZERO
    $ENDIF
  $ENDIF
  IF (ITERM.NE.0) GO TO $80
$L=$ 10 ; $LABEL
  $IF(MODEL='FQ')
    $KD=2
    $SUBST('UP2LQ7')
  $ELSE
    $KD=1
    $SUBST('UP2$(MODP)7')
    CF(NC+1)=FF
  $ENDIF
  $IF(MEP3=1)
    FQ=F
  $ENDIF
  $IF(MEP5=1)
    CALL UXSSDA(NF,M,$H,$IH,TET2)
  $ENDIF
  IF (TSS(NS).EQ.'UUXX') THEN
  ELSE IF (TSS(NS).EQ.'UXFU') THEN
  ELSE
  $IF(TYPE='L')
    $IF(MERIT='M')
      $SUBST('UP0FB9')
      F=CF(NC+1)
    $ELSEIF(MERIT='F')
      $SUBST('UP0FB9')
      F=CF(NC+1)
    $ELSEIF(MERIT='S')
      $SUBST('UP0FB9')
      F=CF(NC+1)
    $ELSEIF(MEP=0)
      F=CF(NC+1)
    $ELSEIF(MEP=2)
      $IF(MEP3<2)
        $SUBST('UP0AF7')
      $ELSE
        IF (NIT.EQ.KIT) THEN
        $SUBST('UP0AF7')
        ENDIF
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(KDS<1)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXUDOT(NF,$G,$S,$IX,-KBF)
  $ENDIF
  ENDIF
  GO TO IMD
$L=$ 20 ; $LABEL
  $IF(MERIT='M')
  $ELSEIF(MERIT='F')
    $SUBST('UP0FB9')
    F=CF(NC+1)
    KS=1
    FS(1,1)=F
    FS(1,2)=FC
    $IF(MEP3=1)
      KT=0
    $ENDIF
  $ELSEIF(MERIT='S')
    $SUBST('UP0FB9')
    F=CF(NC+1)
    KS=1
    FS(1,1)=F
    FS(1,2)=FC
    $IF(MEP3=1)
      KT=0
    $ENDIF
  $ENDIF
  NCA=0
$L=$ 30 ; $LABEL
  $SUBST('UYTS$(CONSTR)G')
  $SUBST('UO2FN4')
  $SUBST('UYFUT2')
  IF (GMAX.LE.TOLG.AND.CMAX.LE.TOLC) THEN
  ITERM=4
  TXFU='GRAD TOL'
  ENDIF
$REM  IF (ITERM.EQ.1.AND.ABS(F).GE.1.0$P 10) THEN
  IF (.FALSE.) THEN
  CALL UOERR1('U2FSF1',88)
  ITERM=-88
  TDXX='LIN. DEP.'
  ENDIF
  IF (ITERM.NE.0) GO TO $80
$L=$ 40 ; $LABEL
  $SUBST('UUSSD1')
  IF (ITERM.NE.0) GO TO $80
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)S')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(KBF>0)
    CALL UXVINF(NF,M,$IX,$JH)
    CALL UXVINF(NF,MC,$IX,$JCG)
    $IF(MODELA='YES') CALL UXVINF(NF,MA,$IX,$JAG)
  $ENDIF
  $SUBST('UYTS$(CONSTR)H')
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UDS$(TYPE)$(DECOMP)$(NUMBER)
*     -----------------------
*
  $SUBST('UDS$(TYPE)$(DECOMP)$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $IF(MERIT='S')
    SWITCH=UXSSMQ(NF,M,HF,IH,JH,S,S)
  $ENDIF
  $SUBST('UD1T$(TYPE)3')
  $IF(MEP2=1)
    CALL UCFMAX(NF,NX,NC,NCA,$IX,$XZL,$XZU,$IC,$CZL,$CZU,$ICA,$S&
,$XO(NF+1),$GO(NF+1),ONE,RMAXD)
  $ELSE
    RMAXD=RMAX
  $ENDIF
  $IF(KBF>0)
    CALL UXVINE(M,$JH)
    CALL UXVINE(MC,$JCG)
    $IF(MODELA='YES') CALL UXVINE(MA,$JAG)
  $ENDIF
  $IF(TYPE='L')
    $IF(MERIT='M')
      $SUBST('UP0FB9')
      FS(1)=CF(NC+1)
      FS(2)=FC
    $ELSEIF(MEP=0)
      F=CF(NC+1)
    $ELSEIF(MEP=2)
      $IF(MEP3<2)
        $SUBST('UP0AF7')
      $ELSE
        IF (NIT.EQ.KIT) THEN
        $SUBST('UP0AF7')
        ENDIF
      $ENDIF
    $ENDIF
  $ENDIF
  IF (ITERM.NE.0) GO TO $80
  IF (IREST.NE.0) GO TO $40
  IF (NIT.EQ.LIT+1) KIT=NIT
$L=$ 50 ; $LABEL
  $SUBST('UYTR$(CONSTR)S')
  CALL UXVCOP(NC+1,$CF,$CFO)
  $IF(MERIT='P')
    $IF(MEP3=1)
      FQO=FQ
    $ENDIF
$L=$ 60 ; $LABEL
    ASSIGN $60 TO IMD
    $SUBST('UZLINS')
    GOTO ($64,$62) ISB+1
$L=$ 62 ; $LABEL
    $IF(MOP2=3)
      CALL UXUDIC(NF,R,$S,$XO,$XL,$XU,$X,$IX)
    $ELSE
      CALL UXUDIR(NF,R,$S,$XO,$X,$IX,-KBF)
    $ENDIF
    $IF(MEP3>0) KD=1
    ISNC=1
    GOTO $10
$L=$ 64 ; $LABEL
    ISNC=2
    $IF(MEP3=2)
      LD=-1
    $ELSE
      $IF(KDA=1) LD=0
      $IF(KDC=1) LD=0
    $ENDIF
  $ELSE
    FFO=FF
    FCO=FC
    $IF(MEP3=1)
$L=$ 54 ; $LABEL
      ASSIGN $54 TO IMD
      $SUBST('US1L09')
      GOTO ($58,$56) ISB+1
$L=$ 56 ; $LABEL
      CALL UXUDIR(NF,R,$S,$XO,$X,$IX,-KBF)
$REM      KD=1
      GOTO $10
$L=$ 58 ; $LABEL
      LD= 0
      IF (ITERS.EQ.8) GO TO $65
    $ENDIF
$L=$ 60 ; $LABEL
    ASSIGN $60 TO IMD
    $SUBST('UZLINS')
    GOTO ($64,$62) ISB+1
$L=$ 62 ; $LABEL
    $IF(MOP2=3)
      CALL UXUDIC(NF,R,$S,$XO,$XL,$XU,$X,$IX)
    $ELSE
      CALL UXUDIR(NF,R,$S,$XO,$X,$IX,-KBF)
    $ENDIF
    ISNC=1
    GOTO $10
$L=$ 64 ; $LABEL
    ISNC=2
    $IF(KDA=1) LD=0
    $IF(KDC=1) LD=0
  $ENDIF
$L=$ 65 ; $LABEL
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  CALL UXVCOP(NC+1,$CFO,$CF)
  IF (IDIR.EQ.0) CALL UYRES1(TSXX)
  CALL UYSET1
  GOTO $40
  ENDIF
  CALL UCFDIR(NF,NX,NC,NCA,$IX,$XZL,$XZU,$IC,$CZL,$CZU,$ICA,$S&
,$XO(NF+1),$GO(NF+1),MIN(R,RMAXD))
  $IF(MERIT='P')
    $IF(MEP3=1)
      F=FQ
    $ENDIF
  $ENDIF
  R=ZERO
  IF (KD.GT.LD) THEN
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$ 70 ; $LABEL
  TXFU=TUXX
  TUXX='NEWTON  '
  $SUBST('UYTRED')
  GOTO $30
$L=$ 80 ; $LABEL
$REM  ISNC=2
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(2)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL3')
    $IF(NORMC>0) $SUBST('UCNRL3')
  $ENDIF
  F=CF(NC+1)
  $SUBST('UCTRF3')
  $SUBST('UO1FN2')
  $ADD(INIT)
    NXFU='U2FSF1'
  $ENDADD
  $EXIT
