$INTERFACE UA0DQ1                                             98/12/01
  $IF(MODELY='YES') $SUBST('UZYSET')
  $EY='EY'
  $EW='EW'
  $IF(GRAPH='NO')
    $NA=1
    $MED=0
    $ADD(SINIT)
      NA=1
      MED=0
    $ENDADD
  $ELSE
    $HELP
      OUTPUT SPECIFICATION
        1 - OUTPUT IN ALL INTEGRATION STEPS
        2 - OUTPUT IN PRESCRIBED MESH POINTS
    $CHECK(MED,2,'1\2',4)
    $HELP
      NUMBER OF MESH POINTS
    $CHECK(NA,50,INT,1)
  $ENDIF
  $IF(MED=2)
    $ADD(SINID)
      CALL UESET1(NA,$AT,TA,TAMAX,HEMAX)
    $ENDADD
  $ENDIF
  $REPEAT
    $HELP
      INTEGRAL PART OF THE OBJECTIVE FUNCTION
        N - INTEGRAL PART EXCLUDED
        Y - INTEGRAL PART INCLUDED
    $CHECK(MODELA,'N','NO\N\YES\Y',1,NO)
    $IF(MODELA='N') $MODELA='NO'
    $IF(MODELA='Y') $MODELA='YES'
    $HELP
      TERMINAL PART OF THE OBJECTIVE FUNCTION
        N - TERMINAL PART EXCLUDED
        Y - TERMINAL PART INCLUDED
    $CHECK(MODELF,'N','NO\N\YES\Y',1,NO)
    $IF(MODELF='N') $MODELF='NO'
    $IF(MODELF='Y') $MODELF='YES'
    $IF(MODELA='NO')
      $IF(MODELF='NO')
        $IF(DIALOG>0)
          $ERASE(MODELA)
          $ERASE(MODELF)
        $ELSE
          $ERROR: OBJECTIVE FUNCTION WAS NOT SPECIFIED
          $STOP
        $ENDIF
      $ENDIF
    $ENDIF
  $UNTIL($DEF(MODELA))
  $IF(MODELA='YES')
    $KDA=0
    $ADD(SINIT)
      YE=ZERO
      WE=ONE
    $ENDADD
  $ENDIF
  $IF(MODELF='YES')
    $KDF=0
    $DIME=NE
    $ADD(SINIT)
      CALL UXVSET(NE,ZERO,$EY)
      CALL UXVSET(NE,ONE,$EW)
    $ENDADD
  $ELSE
    $DIME=1
  $ENDIF
  $ADD(INIT)
    KDA=$KDA
    KDF=$KDF
  $ENDADD
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'0.0$P 0',REAL,2)
  $HELP
    TYPE OF METHOD
      DP5 - DORMAN PRINCE OF THE 5'TH ORDER
      DP8 - DORMAN PRINCE OF THE 8'TH ORDER
  $CHECK(SOLVER,'DP8','DP5\DP8\EX1',2,NO)
  $IF(MODELA='YES')
    $MEL='($NE+1)'
  $ELSE
    $MEL='$NE'
  $ENDIF
  $ADD(REAL,'\$AT($NA)\$AY($NA*$NE)\$YA($MEL)\$EY($DIME)\$EW($DIME)')
      $ADD(SINID)
        CALL UESET2(NA,NE,$AT,$AY,$YA,TA)
      $ENDADD
      $IF(MODELY='YES')
        $SUBST('UE0Y01')
        CALL UXVCOP(NE,$YA,$AY)
      $ENDIF
 $00  CALL UA0DQ1(NA,NE,MEL,$AT,$AY,$YA,$EY,$EW,ETA9,F,TA,HE,MED,
     & MED1,MED2,IER)
      GOTO ($30,$10) ISB+1
 $10  CONTINUE
      $LET=$00
      $LED=$20
      $LES=$10
      $SUBST('UEV$SOLVER')
 $20  CONTINUE
      $SUBST('UE0DQ1')
      $GO TO $10
 $30  CONTINUE
      $ADD(INIT)
        MEL=$MEL
        NAXX='UA0DQ1'
      $ENDADD
      $EXIT
