$INTERFACE US0G03                                             97/12/01
  $HELP
    TYPE OF THE TRUST REGION METHOD.
      0 - BASIC TRUST REGION METHOD
      1 - STRICT TRUST REGION METHOD
  $CHECK(MES,0,'0\1')
  $HELP
    STRATEGY FOR STEP DECREASING
      1 - FLETCHER
      2 - POWELL
      3 - SAFEGUARDED INTERPOLATION
  $CHECK(MES1,3,'1\2\3')
  $HELP
    STRATEGY FOR STEP INCREASING
      1 - FLETCHER
      2 - POWELL
  $CHECK(MES2,2,'1\2')
  $DEFAULT='0.10$P 0'
  $IF(MES>0) $DEFAULT='0.001$P 0'
  $HELP
    FIRST TOLERANCE FOR RATIO DF/DFPRED. STEP BOUND IS
    DECREASED IF DF/DFPRED<EPS3
  $CHECK(EPS3,DEFAULT,REAL,4)
  $HELP
    SECOND+INITIAL TOLERANCE FOR RATIO DF/DFPRED. STEP BOUND
    IS INCREASED IF IT IS ACTIVE AND DF/DFPRED>EPS.
    (STEP BOUND IS DECREASED IF (DF/DFPRED-EPS+EPS4) < EPS3)
  $CHECK(EPS4,'0.70$P 0',REAL,4)
  $HELP
    LOWER BOUND FOR STEPSIZE REDUCTION
  $CHECK(BET1,'0.05$P 0',REAL,4)
  $DEFAULT='0.50$P 0'
  $IF(MES1=3) $DEFAULT='0.75$P 0'
  $HELP
    UPPER BOUND FOR STEPSIZE REDUCTION
  $CHECK(BET2,DEFAULT,REAL,4)
  $HELP
    LOWER BOUND FOR STEPSIZE EXPANSION
  $CHECK(GAM1,'1.8$P 0',REAL,4)
  $HELP
    UPPER BOUND FOR STEPSIZE EXPANSION
  $CHECK(GAM2,'1.0$P 6',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XMAX,'1.0$P 3',REAL,2)
  $HELP
    MAXIMUM NUMBER OF ZERO STEPS IN ONE ITERATION
  $CHECK(MRED,10,INT,4)
  CALL US0G03(EPS3,EPS4,BET1,BET2,GAM1,GAM2,RO,R,FO,F,PO,PP,XDEL&
,XDELO,XMAX,GNORM,SNORM,PAR1,RMAX,KTERS,MES,MES1,MES2,MRED,$KDS)
$REM  $ADD(REAL,'\EPS3\EPS4\BET1\BET2\GAM1\GAM2\RO\R\FO\F\PO\PP\XDEL&
$REM  \XDELO\XMAX\GNORM\SNORM\PAR1\RMAX')
$REM  $ADD(INTEGER,'\KTERS\MES,MES1\MES2\MRED')
  $ADD(INIT)
    NSXX='US0G03'
  $ENDADD
  $EXIT
